#ifndef ErrorPackageNameStandard_h
#define ErrorPackageNameStandard_h

#ifndef NamingError_h
#include "NamingError.h"
#endif

namespace doctorj 
{
    class ErrorPackageNameStandard : public NamingError 
    {
    public:
        
        ErrorPackageNameStandard();

        /**
         * Creates the error.
         */
        ErrorPackageNameStandard(Reporter* const reporter, AstItem* const item);

        virtual ~ErrorPackageNameStandard();

        /**
         * Returns the title of this error.
         */
        virtual string title() const;

        /**
         * Writes the long description of this error to the given output stream.
         */
        virtual void writeDescription(ostream& os) const;

        /**
         * Returns the message describing this error. 
         */
        virtual string message() const;

    };

}

#endif //! ErrorPackageNameStandard_h
