#ifndef iterext_h
#define iterext_h

/**
 * Nonconst version.
 */
#define EACH(ContainerType, Container, Iterator) \
    for (ContainerType::iterator stop = (Container).end(), \
         Iterator = (Container).begin(); \
        Iterator != stop; \
        ++Iterator) \

/**
 * Const version.
 */
#define EACHC(ContainerType, Container, Iterator) \
    for (ContainerType::const_iterator stop = (Container).end(), \
         Iterator = (Container).begin(); \
        Iterator != stop; \
        ++Iterator) \

#endif //! iterext_h
